// cl_make_heap_V_I().

// General includes.
#include "cl_sysdep.h"

// Specification.
#include "cl_V_I.h"


// Implementation.

#include "cl_abort.h"
#include "cl_offsetof.h"

static void cl_vector_integer_destructor (cl_heap* pointer)
{
	(*(cl_heap_V_I*)pointer).~cl_heap_V_I();
}
AT_INITIALIZATION(ini_cl_vector_integer)
{ cl_register_typetag(cl_typetag_vector_integer,cl_vector_integer_destructor); }

struct cl_heap_V_I_general : public cl_heap_V_I {
	cl_I data[1];
	// Standard allocation disabled.
	void* operator new (size_t size) { (void)size; cl_abort (); return NULL; }
	// Standard deallocation disabled.
	void operator delete (void* ptr) { unused ptr; cl_abort(); }
	// No default constructor.
	cl_heap_V_I_general ();
};

static inline cl_heap_V_I_general * outcast (cl_V<cl_I>* vec)
{
	return (cl_heap_V_I_general *)((char *) vec - offsetof(cl_heap_V_I_general,v));
}
static inline const cl_heap_V_I_general * outcast (const cl_V<cl_I>* vec)
{
	return (const cl_heap_V_I_general *)((const char *) vec - offsetof(cl_heap_V_I_general,v));
}

static cl_I general_element (const cl_V<cl_I>* vec, uintL index)
{
	return outcast(vec)->data[index];
}

static void general_set_element (cl_V<cl_I>* vec, uintL index, const cl_I& x)
{
	outcast(vec)->data[index] = x;
}

static void general_do_delete (cl_V<cl_I>* vec)
{
	var cl_heap_V_I_general* hv = outcast(vec);
	var uintL len = hv->v.length();
	for (var uintL i = 0; i < len; i++)
		hv->data[i].~cl_I();
}

static cl_V_vectorops<cl_I> general_vectorops = {
	general_element,
	general_set_element,
	general_do_delete
};

cl_heap_V_I* cl_make_heap_V_I (uintL len)
{
	var cl_heap_V_I_general* hv = (cl_heap_V_I_general*) cl_malloc_hook(offsetofa(cl_heap_V_I_general,data)+sizeof(cl_I)*len);
	hv->refcount = 1;
	hv->typetag = cl_typetag_vector_integer;
	new (&hv->v) cl_V<cl_I> (len,&general_vectorops);
	for (var uintL i = 0; i < len; i++)
		new (&hv->data[i]) cl_I ();
	return hv;
}
